core/core/urls.py
from django.conf import settings
from django.conf.urls import url, include
from django.contrib import admin
from django.conf.urls.static import static
from client.views import login_view, logout_view

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('client.urls')),
    url(r'^clients/', include('client.urls', namespace='client')),
    url(r'^visit/', include('vist.urls', namespace='visit')),
    url(r'^safe/', include('safe.urls', namespace='safe')),
    url(r'^appointment/', include('appointments.urls', namespace='appointment')),
    url(r'^lab/', include('labs.urls', namespace='labs')),
    url(r'^login/$', login_view.as_view(), name='login'),
    url(r'^logout/$', logout_view.as_view(), name='logout'),

]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

core/labs/urls.py
from django.conf.urls import url
from .views import (
    ListLabs, AddLab, DeleteLab, AddItemType, ListItemType,
    AddItemToLab, LabDetailView, DeleteItemFromLab, LabsDue,
    DeleteItemType
)
from django.views.generic.base import RedirectView

urlpatterns = [
    url(r'^$', ListLabs.as_view(), name="index"),
    url(r'^itemstype$', ListItemType.as_view(), name="item-type-index"),
    url(r'^add/$', AddLab.as_view(), name="add"),
    url(r'^add/item/type$', AddItemType.as_view(), name="add-item-type"),
    url(r'^due/$', LabsDue.as_view(), name="due"),
    url(r'^add/item/$', AddItemToLab.as_view(), name="add-item"),
    url(r'^(?P<pk>\d+)/delete/item/$', DeleteItemFromLab.as_view(), name="delete-item"),
    url(r'^(?P<pk>\d+)/delete/item/type$', DeleteItemType.as_view(), name="delete-item-type"),
    url(r'^(?P<pk>\d+)/delete/$', DeleteLab.as_view(), name="delete"),
    # url(r'^(?P<pk>\d+)/update/$', UpdateClientView.as_view(), name="update"),
    url(r'^(?P<pk>\d+)/show/$', LabDetailView.as_view(), name="show"),
    # url(r'^search/$', TweetListView.as_view(), name="list"),

]

core/safe/urls.py
from django.conf.urls import url
from .views import AddBillToClient, GetClientBills,UpdateSafeView,SafeDetailView,AddPaymentToClient,GetPaymentsByDay
from django.views.generic.base import RedirectView

urlpatterns = [
    # url(r'^$', VisitListView.as_view(), name="index"),
    url(r'^(?P<pk>\d+)/add/$', AddBillToClient.as_view(), name="add"),
    url(r'^(?P<pk>\d+)/list/$', GetClientBills.as_view(), name="list"),
    url(r'^(?P<pk>\d+)/detail/$', SafeDetailView.as_view(), name="detail"),
    url(r'^(?P<pk>\d+)/add/payment/$', AddPaymentToClient.as_view(), name="add_payment"),
    url(r'^(?P<pk>\d+)/update/$', UpdateSafeView.as_view(), name="update"),
    url(r'^payments/$', GetPaymentsByDay.as_view(), name="filter"),
    # url(r'^search/$', TweetListView.as_view(), name="list"),

]

core/safe/models.py
from django.db import models
from client.models import Client


# Create your models here.

class Safe(models.Model):
    client = models.ForeignKey(Client)
    amount = models.FloatField(default=0)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.client.name + " " + self.client.mobile

    def get_paid(self):
        total_paid = 0
        for payment in self.payments_set.all():
            total_paid += payment.amount
        return total_paid

class Payments(models.Model):
    safe = models.ForeignKey(Safe)
    amount = models.FloatField(null=False, blank=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.created_at

    def get_user(self):
        return self.safe.client.name

core/safe/forms.py
from django import forms
from .models import Safe, Payments


class AddBillForm(forms.ModelForm):
    class Meta:
        model = Safe
        fields = ['amount']
        labels = {
            "amount": "القيمة"
        }
        widgets = {
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
        }

#
# class AddBillForm(forms.ModelForm):
#     class Meta:
#         model = Safe
#         fields = ['client', 'total', 'paid']
#         widgets = {
#             'client': forms.Select(attrs={'class': 'form-control'}),
#             'total': forms.NumberInput(attrs={'class': 'form-control'}),
#             'paid': forms.NumberInput(attrs={'class': 'form-control'}),
#         }

class AddPaymentForm(forms.ModelForm):
    class Meta:
        model = Payments
        labels={
            "amount":"القيمة"
        }
        fields = ['amount']
        widgets = {
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
        }

core/safe/views.py
from django.shortcuts import render
from django.contrib import messages
from django.views.generic import View, UpdateView, DetailView
from client.models import Client
from .models import Safe, Payments
from .forms import AddPaymentForm, AddBillForm
from django.contrib.messages.views import SuccessMessageMixin

from django.urls import reverse_lazy, reverse
from django.shortcuts import get_object_or_404, render
from django.http import JsonResponse, HttpResponseRedirect


# Create your views here.



class AddBillToClient(View):
    template_name = "partials/safe/safe_add_view.html"

    the_form = AddBillForm

    def get(self, request, *args, **kwargs):
        client = Client.objects.get(pk=kwargs['pk'])
        # safe = client.safe_set.first()
        context = {'client': client, 'form': self.the_form}
        return render(request, self.template_name, context)

    def post(self, request, *args, **kwargs):
        form = self.the_form(request.POST)
        client = Client.objects.get(pk=kwargs['pk'])
        if form.is_valid():
            safe = form.save(commit=False)
            safe.client = client
            # <process form cleaned data>
            safe.save()
            payment = Payments()
            payment.safe = safe
            payment.amount = request.POST.get('to_pay')
            payment.save()
            messages.success(
                request, 'Client %s has.' % client.name)

        return HttpResponseRedirect(reverse('safe:detail', kwargs={'pk': safe.id}))


class GetClientBills(View):
    template_name = "partials/safe/safe_client_list_view.html"

    # the_form = AddBillForm
    def get(self, request, *args, **kwargs):
        client = Client.objects.filter(pk=kwargs['pk']).first()
        safe = client.safe_set.all()
        context = {'safe': safe, 'client': client.name + " " + client.mobile}
        return render(request, self.template_name, context)


class UpdateSafeView(SuccessMessageMixin, UpdateView):
    model = Safe
    template_name = "partials/safe/safe_add_view.html"
    fields = ['amount']
    success_message = 'Amount has been Saved successfully.'

    def get_object(self, queryset=None):
        object = Safe.objects.get(id=self.kwargs['pk'])
        return object

    def get_success_url(self):
        return reverse('safe:list', kwargs={'pk': self.kwargs['pk']})


class SafeDetailView(View):
    template_name = "partials/safe/list_view.html"

    def get(self, request, *args, **kwargs):
        object = Safe.objects.get(id=kwargs['pk'])
        object_list = object.payments_set.all()
        overall_amount = object.amount
        context = {'object_list': object_list, 'overall': overall_amount,
                   'paid': object.get_paid(),
                   'client': object.client.name + " " + object.client.mobile}
        return render(request, self.template_name, context)


class AddPaymentToClient(View):
    template_name = "partials/safe/add_view.html"
    form = AddPaymentForm

    def get(self, request, *args, **kwargs):
        safe = Safe.objects.get(pk=kwargs['pk'])
        client = safe.client
        # client = Client.objects.get(pk=kwargs['pk'])
        context = {'form': self.form, 'client': client.name + " " + client.mobile}
        return render(request, self.template_name, context)

    def post(self, request, *args, **kwargs):
        form = self.form(request.POST)
        safe = Safe.objects.get(pk=kwargs['pk'])
        context = {'form': self.form, 'client': safe.client.name + " " + safe.client.mobile}
        total_amount = safe.amount
        if (total_amount - safe.get_paid()) >= float(request.POST.get('amount')):
            if form.is_valid():
                # <process form cleaned data>
                payment = form.save(commit=False)
                payment.safe = safe
                payment.save()
                messages.success(
                    request, 'Payment has been added successfully.')
                # return render(request, self.template_name, context)
            return HttpResponseRedirect(reverse('safe:detail', kwargs={'pk': safe.id}))
        else:
            messages.error(request, 'The payment is greater than the due.')
            return render(request, self.template_name, context)


class GetPaymentsByDay(View):
    template_name = "partials/safe/list_view.html"

    def get(self, request, *args, **kwargs):
        payments = Payments.objects.filter(created_at__icontains=request.GET.get('date'))
        overall = 0
        for payment in payments:
            overall += payment.amount
        context = {'object_list':payments,'overall':overall}
        return render(request, self.template_name, context)

core/templates/partials/safe/add_view.html
{% extends "base.html" %} {% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h3 class="page-header text-center"><span class="text-danger">{{ client }}</span>اضافة قيمة لــ</h3>
                {% if messages %}
                    <ol class="breadcrumb">
                        <div class="alert alert-success">
                            <ul class="messages">
                                {% for message in messages %}
                                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </ol>
                {% endif %}
                <div class="col-lg-12">
                    <div class="panel panel-default center-block">
                        <div class="panel-body">
                            <div class="tab-content">
                                <div id="levelInfo" class="tab-pane fade in active">
                                    <form action="" method="post">
                                        {% csrf_token %}
                                        {% if form.errors %}
                                            {% for field in form %}
                                                {% for error in field.errors %}
                                                    <div class="alert alert-danger">
                                                        <strong>{{ error|escape }}</strong>
                                                    </div>
                                                {% endfor %}
                                            {% endfor %}
                                            {% for error in form.non_field_errors %}
                                                <div class="alert alert-danger">
                                                    <strong>{{ error|escape }}</strong>
                                                </div>
                                            {% endfor %}
                                        {% endif %}
                                        </ol>
                                        {{ form.as_p }}
                                        <input type="submit" class="btn btn-success btn-block" value="اضف">
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /.col-lg-12 -->
    </div>
{% endblock content %}

core/templates/partials/safe/list_view.html
{% extends "base.html" %}

{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h3 class="page-header"><span class="text-success">{{ client }}</span> payments </h3>
                <h4 class="text-primary">Total Amount: {{ overall }}</h4>
                {% if paid %}
                     <h4 class="text-danger">Total Paid: {{ paid }}</h4>
                {% endif %}
                <br>
                {% if messages %}
                    <ol class="breadcrumb">
                        <div class="alert alert-success">
                            <ul class="messages">
                                {% for message in messages %}
                                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </ol>
                {% endif %}
            </div>

            <div class="col-lg-12">
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>التسلسل</th>
                        <th class="text-center">Paid</th>
                        <th>المستخدم</th>
                        <th class="text-center">تاريخ الانشاء</th>
                        <th class="text-center">تاريخ التعديل</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in object_list %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td>{{ obj.amount }}</td>
                            <td>{{ obj.get_user }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>
                            <td>{{ obj.updated_at|timesince }} ago.</td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <!-- /.table-responsive -->

            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}

core/templates/partials/safe/safe_add_view.html
{% extends "base.html" %} {% block content %}
<div id="page-wrapper">
    <div class="row">
        <div class="col-lg-12">
            <h1 class="page-header text-center">الخزنة</h1>

            <div class="col-lg-12">
                <div class="panel panel-default center-block">
                    <div class="panel-body">
                        <div class="tab-content">
                            <div id="levelInfo" class="tab-pane fade in active">
                                <form action="" method="post">
                                    {% csrf_token %}
                                    {% if form.errors %}
                                    {% for field in form %}
                                    {% for error in field.errors %}
                                    <div class="alert alert-danger">
                                        <strong>{{ error|escape }}</strong>
                                    </div>
                                    {% endfor %}
                                    {% endfor %}
                                    {% for error in form.non_field_errors %}
                                    <div class="alert alert-danger">
                                        <strong>{{ error|escape }}</strong>
                                    </div>
                                    {% endfor %}
                                    {% endif %}
                                    </ol>
                                    {% include 'partials/safe/safe_form.html' %}
                                    <input class="btn btn-success btn-block" type="submit" value="اضف">
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- /.col-lg-12 -->
</div>
{% endblock content %}

core/templates/partials/safe/safe_client_list_view.html
{% extends "base.html" %}

{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h3 class="page-header"><span class="text-danger">{{ client }}</span> بيان </h3>
                {% if messages %}
                    <ol class="breadcrumb">
                        <div class="alert alert-success">
                            <ul class="messages">
                                {% for message in messages %}
                                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </ol>
                {% endif %}
            </div>

            <div class="col-lg-12">
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>ID</th>
                        <th class="text-center">القيمة</th>
                        <th class="text-center">المدفوع</th>
                        <th class="text-center">تاريخ الانشاء</th>
                        <th class="text-center">تاريخ التعديل</th>
                        <th class="text-center">الاعدادات</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in safe %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td><a href="{% url 'client:show' obj.id %}">{{ obj.amount }}</a></td>
                            <td>{{ obj.get_paid }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>
                            <td>{{ obj.updated_at|timesince }} ago.</td>
                            <td class="text-center">
                                <div class="btn-group">
                                  <a href="{% url 'safe:add_payment' obj.id %}" class="btn btn-warning" title="Add"
                                       data-original-title="Add">
                                        <i class="fa fa-money"></i>
                                    </a>
                                    <a href="{% url 'safe:update' obj.id %}" class="btn btn-success" title="Edit"
                                       data-original-title="Edit">
                                        <i class="fa fa-pencil"></i>
                                    </a>

                                    <a href="{% url 'safe:detail' obj.id %}" class="btn btn-primary" title="Detail"
                                       data-original-title="Detail">
                                        <i class="fa fa-eye"></i>
                                    </a>

                                </div>

                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <!-- /.table-responsive -->

            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}

core/templates/partials/safe/safe_form.html
<div class="form-group">
 <h3>{{client.name}} - {{client.mobile}}</h3>
</div>

{{form.as_p}}

<div class="form-group">
    <label for="paid">المدفوع الان</label>
    <input type="number" class="form-control" name="to_pay">
</div>